(function() {
  /*
  This module includes **only** the validations that can be shared between the
  server and the client. _Anything that involved database lookups to check
  uniqueness, ect, must be done separately._
  
  Each function receives the attributes and returns an object of errors.
  {field: [errors]}
  A return value of `{}` is success.
  
  */  var PROJECT_RE, USER_RE;
  USER_RE = /^[a-zA-Z0-9]{2,}$/;
  PROJECT_RE = /^[a-zA-Z0-9_.-]+$/;
  module.exports = {
    user: function(attrs) {
      var errors, name, password, password_conf;
      name = attrs.name, password = attrs.password, password_conf = attrs.password_conf;
      errors = {};
      if (!name) {
        errors.name = ["Username is required"];
      }
      if (!password) {
        errors.password = ["Password is required"];
      }
      if (!USER_RE.test(name)) {
        errors.name || (errors.name = ["Username must match " + USER_RE + "."]);
      }
      if (!((password != null ? password.length : void 0) >= 6)) {
        errors.password || (errors.password = "Password is too short");
      }
      if (!password_conf) {
        errors.password_conf = ["Password confirmation is required"];
      }
      if (password !== password_conf) {
        errors.password_conf || (errors.password_conf = ["Confirmation must match"]);
      }
      return errors;
    },
    project: function(attrs) {
      var errors, name;
      name = attrs.name;
      errors = {};
      if (!name) {
        errors.name = ["Project name is required"];
      }
      if (!PROJECT_RE.test(name)) {
        errors.name || (errors.name = ["The project name must match " + PROJECT_RE]);
      }
      return errors;
    }
  };
}).call(this);
