(function() {
  /*
  Handle authentication.
  
  Helpful links:
  
  * http://blog.nodeknockout.com/post/9417557660/countdown-
    to-ko-23-login-with-password-facebook
  * https://github.com/bnoguchi/everyauth
  * https://github.com/bnoguchi/everyauth/blob/master/example/server.js
  
  */  var PasswordAuth, User, everyauth, express;
  everyauth = require('everyauth');
  express = require('express');
  User = require('../models/user');
  module.exports = function(app) {
    app.use(everyauth.middleware());
    return everyauth.helpExpress(app);
  };
  everyauth.everymodule.findUserById(function(id, callback) {
    return User.find(id, function(user) {
      return callback(null, user);
    });
  });
  PasswordAuth = (function() {
    function PasswordAuth() {}
    PasswordAuth.authenticate = function(username, password) {
      var errors, promise;
      errors = [];
      if (!username) {
        errors.push("Missing username");
      }
      if (!password) {
        errors.push("Missing password");
      }
      if (errors.length) {
        return errors;
      }
      promise = this.Promise();
      User.where({
        name: username
      }, function(users) {
        var user;
        user = users[0];
        if (!user) {
          return promise.fulfill(["No user exists with that name"]);
        }
        if (user.password !== password) {
          return promise.fulfill(["Incorrect password"]);
        }
        return promise.fulfill(user);
      });
      return promise;
    };
    PasswordAuth.validate = function(attrs, errors) {
      var promise, user;
      user = new User({
        name: attrs.login,
        password: attrs.password,
        password_conf: attrs.password_conf
      });
      promise = this.Promise();
      user.valid(function(valid) {
        errors = valid ? [] : user.errors;
        return promise.fulfill(errors);
      });
      return promise;
    };
    PasswordAuth.register = function(attrs) {
      var user;
      user = new User({
        name: attrs.login,
        password: attrs.password,
        password_conf: attrs.password_conf
      });
      user.save();
      return user;
    };
    return PasswordAuth;
  })();
  everyauth.password.loginWith("login").getLoginPath("/login").postLoginPath("/login").loginView("users/login.jade").loginLocals({
    title: "Log In - Stratus"
  }).authenticate(PasswordAuth.authenticate).getRegisterPath("/register").postRegisterPath("/register").registerView("users/register.jade").registerLocals({
    title: "Register - Stratus"
  }).validateRegistration(PasswordAuth.validate).registerUser(PasswordAuth.register).loginSuccessRedirect("/").registerSuccessRedirect("/").extractExtraRegistrationParams(function(req) {
    return {
      password_conf: req.body.password_conf
    };
  });
}).call(this);
