(function() {
  /*
  TODO: These should be served by `express.static` or a CDN.
  
  */  var Project, bundle, express, extensions, fs;
  express = require('express');
  fs = require('fs');
  bundle = require('stratus-bundle');
  Project = require('../models').Project;
  extensions = require('../models/extensions');
  module.exports = function(app) {
    app.get("/bundles/:language/icon.png", function(req, res) {
      var language;
      language = req.param("language");
      return fs.readFile("" + bundle.dir + "/" + language + "/icon.png", function(err, data) {
        if (err) {
          return res.send(err);
        }
        res.writeHead(200, {
          "Content-Type": express.static.mime.types.png
        });
        return res.end(data, "binary");
      });
    });
    app.get("/bundles/:language.json", function(req, res) {
      var language;
      language = req.param("language");
      return bundle(language).toJSON(function(json) {
        return res.json(json);
      });
    });
    return app.get("/plugins.:format", function(req, res) {
      var format, user;
      user = req.user;
      if (!user) {
        return res.send(403);
      }
      format = req.params.format;
      return Project.where({
        user_id: user.id,
        name: ".stratus"
      }, function(projects) {
        var project;
        project = projects[0];
        res.contentType("file." + format);
        if (!project) {
          return res.send('/*no ".stratus" project*/');
        } else if (format === "js") {
          return extensions(project.path).js(function(err, jsCode) {
            if (err) {
              throw err;
            }
            return res.send(jsCode);
          });
        } else if (format === "css") {
          return extensions(project.path).css(function(err, cssCode) {
            if (err) {
              throw err;
            }
            return res.send(cssCode);
          });
        } else {
          return res.send(404);
        }
      });
    });
  };
}).call(this);
