(function() {
  var Project, _;
  _ = require('underscore');
  Project = require('../models').Project;
  module.exports = function(app) {
    return app.get("/", function(req, res) {
      var user;
      user = req.user;
      if (!user) {
        return res.render("index");
      }
      return Project.where({
        user_id: user.id
      }, function(projects) {
        var projectData;
        projectData = _.map(projects, function(project) {
          return {
            name: project.name,
            isPublic: project.isPublic
          };
        });
        return res.render("index", {
          data: {
            projects: _.sortBy(projectData, function(p) {
              return p.name;
            }),
            user: {
              name: user.name
            }
          }
        });
      });
    });
  };
}).call(this);
