(function() {
  var color, hashToAttributes;
  color = require('stratus-color');
  hashToAttributes = function(hash) {
    var html, k, v;
    html = "";
    for (k in hash) {
      v = hash[k];
      html += " " + k + "='" + v + "'";
    }
    return html;
  };
  module.exports = {
    hashToAttributes: hashToAttributes,
    imageTag: function(src, attrs) {
      var extra;
      if (attrs == null) {
        attrs = null;
      }
      extra = attrs ? hashToAttributes(attrs) : "";
      return "<img src='/images/" + src + "'" + extra + "/>";
    },
    errorMessages: function(errors) {
      if (!errors) {
        return "";
      }
      return "<ul class='errors'><li>" + (errors.join("</li><li>")) + "</li></ul>";
    },
    jsData: function(data) {
      return "window.data = " + (JSON.stringify(data)) + ";";
    },
    themeCSS: function(theme) {
      if (theme == null) {
        theme = null;
      }
      return color.css(theme || "Idlefingers", {
        root: "fractus",
        cursor: "fractus-cursor",
        selection: "fractus-selection"
      });
    }
  };
}).call(this);
