(function() {
  /*
  
  
  */  var DB_ROOT, FsModel, fs, path, _;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  fs = require('fs');
  path = require('path');
  _ = require('underscore');
  DB_ROOT = path.resolve(process.env.HOME, ".stratus", process.env.NODE_ENV || "development");
  if (!path.existsSync(DB_ROOT)) {
    fs.mkdirSync(DB_ROOT, 0755);
  }
  module.exports = FsModel = (function() {
    FsModel.collections = {};
    FsModel.prototype.modelName = "OVERRIDE";
    function FsModel(options) {
      if (options == null) {
        options = {};
      }
      this.errors = [];
    }
    FsModel.prototype.attributes = function() {};
    FsModel.prototype.valid = function(callback) {};
    FsModel.prototype.save = function(callback) {
      return this.valid(__bind(function(valid) {
        if (!valid) {
          return typeof callback === "function" ? callback(false) : void 0;
        }
        return this.preSave(__bind(function() {
          if (!this.id) {
            this.id = this._generateId();
          }
          FsModel.collections[this.modelName][this.id] = this.attributes();
          return this._writeDb(function() {
            return typeof callback === "function" ? callback(true) : void 0;
          });
        }, this));
      }, this));
    };
    FsModel.prototype.preSave = function(callback) {
      return callback();
    };
    FsModel.prototype.destroy = function(callback) {
      delete FsModel.collections[this.modelName][this.id];
      this.id = null;
      this._writeDb();
      return typeof callback === "function" ? callback() : void 0;
    };
    FsModel.all = function(callback) {
      return callback(FsModel.collections[this.modelName]);
    };
    FsModel.find = function(id, callback) {
      return callback(FsModel.collections[this.modelName][id]);
    };
    FsModel.where = function(constraints, callback) {
      var attrs, constrainField, constrainValue, found, id, records, valid;
      found = [];
      records = FsModel.collections[this.modelName];
      for (id in records) {
        attrs = records[id];
        valid = true;
        for (constrainField in constraints) {
          constrainValue = constraints[constrainField];
          if (attrs[constrainField] !== constrainValue) {
            valid = false;
          }
        }
        if (valid) {
          found.push(new this(attrs));
        }
      }
      return callback(found);
    };
    FsModel.count = function(callback) {
      return callback(Object.keys(FsModel.collections[this.modelName]).length);
    };
    FsModel.prototype._dbPath = function() {
      this.__dbPath || (this.__dbPath = path.join(DB_ROOT, "" + this.modelName + ".json"));
      return this.__dbPath;
    };
    FsModel.prototype._db = function() {
      var _base, _name;
      return (_base = FsModel.collections)[_name = this.modelName] || (_base[_name] = path.existsSync(this._dbPath()) ? JSON.parse(fs.readFileSync(this._dbPath())) : {});
    };
    FsModel.prototype._writeDb = function(callback) {
      var data;
      data = JSON.stringify(FsModel.collections[this.modelName]);
      return fs.writeFile(this._dbPath(), data, callback);
    };
    FsModel.prototype._generateId = function() {
      var id;
      id = "" + Math.floor(Math.random() * 10000000);
      if (!FsModel.collections[this.modelName][id]) {
        return id;
      } else {
        return this._generateId();
      }
    };
    return FsModel;
  })();
}).call(this);
