(function() {
  var Model, User, validate, _;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  _ = require('underscore');
  Model = require('./model');
  validate = require('../../../client/shared/validate');
  User = (function() {
    __extends(User, Model);
    User.modelName = "users";
    User.prototype.modelName = "users";
    function User(options) {
      if (options == null) {
        options = {};
      }
      User.__super__.constructor.call(this, options);
      this.id = options.id, this.name = options.name, this.password = options.password, this.password_conf = options.password_conf, this.email = options.email;
    }
    User.prototype.attributes = function() {
      return {
        id: this.id,
        name: this.name,
        password: this.password,
        email: this.email
      };
    };
    User.prototype.valid = function(callback) {
      this.errors = _.values(validate.user(this));
      return User.where({
        name: this.name
      }, __bind(function(users) {
        if (users.length) {
          this.errors.push("That username is already taken.");
        }
        return callback(this.errors.length === 0);
      }, this));
    };
    return User;
  })();
  (new User())._db();
  module.exports = User;
}).call(this);
