(function() {
  var parseCookie;
  parseCookie = require('connect').utils.parseCookie;
  module.exports = function(io, sessionStore) {
    return io.set("authorization", function(data, accept) {
      if (!data.headers.cookie) {
        return accept("No cookie transmitted.", false);
      }
      data.cookie = parseCookie(data.headers.cookie);
      data.sessionId = data.cookie["express.sid"];
      return sessionStore.get(data.sessionId, function(err, session) {
        if (err) {
          return accept(err.message, false);
        } else if (!session || !session.auth) {
          return accept("not authorized", false);
        }
        data.session = session;
        return accept(null, true);
      });
    });
  };
}).call(this);
